<?php

namespace app\modules\Scorecard\controllers;


use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;
use Yii;
use Mpdf\Mpdf;
use yii\base\InvalidArgumentException;
use yii\web\BadRequestHttpException;
use yii\filters\AccessControl;
use common\models\User;
use yii\helpers\ArrayHelper;
use PhpParser\Node\Expr\Print_;
use yii\bootstrap5\ActiveForm;
use yii\helpers\Url;
use app\modules\Scorecard\models\Scorecard;
use yii\web\Session;
use yii\db\Query;
use yii\base\DynamicModel;
use SimpleSoftwareIO\QrCode\Generator; // Use the Generator class directly

class ScorecardController extends \yii\web\Controller
{

    public function actions()
    {
        return [
            'error' => [
                'class' => \yii\web\ErrorAction::class,
            ],
            'captcha' => [
                'class' => \yii\captcha\CaptchaAction::class,
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }


    public function actionIndex()
    {
        return $this->redirect(['../site/login']);
        die;
        $session = Yii::$app->session;
        if (isset(yii::$app->params['isMobileOTP']) and yii::$app->params['isMobileOTP'] == 1) {
            $AccessPermission = $session->get('AccessPermissionAdmit');
            if (empty($AccessPermission)) {
                return $this->redirect('scorecardmobile');
            }
        }
        $model = new Scorecard();

        //day name
        for ($i = 1; $i <= 31; $i++) {
            $DobDate[str_pad($i, 2, '0', STR_PAD_LEFT)] = str_pad($i, 2, '0', STR_PAD_LEFT);
        }
        //month name
        for ($m = 1; $m <= 12; ++$m) {
            $DobMonth[str_pad($m, 2, '0', STR_PAD_LEFT)] = date('F', mktime(0, 0, 0, $m, 1));
        }

        $examDate = strtotime(date('Y-m-d', strtotime(yii::$app->params['examStartDate'])) . "-3 year");
        $MinYear = date('Y', ($examDate));
        $examDate = strtotime(date('Y-m-d', strtotime(yii::$app->params['examStartDate'])) . "-94 year");
        $MaxYear = date('Y', ($examDate));

        $DobYear = array();
        for ($year = $MaxYear; $year <= $MinYear; $year++) {
            $DobYear[$year] = $year;
        }

        if ($this->request->isPost) {
            if ($model->load(Yii::$app->request->post()) && $model->validate()) {
                $data = Yii::$app->request->post();
                foreach ($data['Scorecard'] as $key => $value) {
                    $data['Scorecard']["$key"] = Yii::$app->SanatizeInput->getInput($value);
                }
                if (isset($data['Scorecard']['Day'], $data['Scorecard']['Month'], $data['Scorecard']['Year']) && !empty($data['Scorecard']['Day']) && !empty($data['Scorecard']['Month']) && !empty($data['Scorecard']['Year'])) {
                    $Day = $data['Scorecard']['Day'];
                    $Month = $data['Scorecard']['Month'];
                    $Year = $data['Scorecard']['Year'];
                    //$candiDOB = $Year . '-' . $Month . '-' . $Day;
                    $candiDOB = $Day . '-' . $Month . '-' . $Year;
                    $DOB = trim($candiDOB);
                    $model_data = [];

                    if (!empty($data['Scorecard']['ApplicationNumber'])) {
                        $candiApplicationNo = "appno='" . $data['Scorecard']['ApplicationNumber'] . "'";
                        $model_data = Yii::$app->db->createCommand("exec getCommonDataSP :select, :input, :table")
                            ->bindValue(':select', '*')
                            ->bindValue(':input', "WHERE $candiApplicationNo AND dob='$DOB' order by exam_date,exam_shft")
                            ->bindValue(':table', 'Swayam_13_ScoreCard2lot')
                            ->queryAll();

                        if (isset($model_data) && !empty($model_data)) {
                            Yii::$app->session->set('ApplicationNumber', $model_data[0]['appno']);
                            // log
                            Yii::$app->db->createCommand("exec spAdmitCardLog :ApplicationNumber,:CandidateIP,:CandidateDownload")
                                ->bindValue(':ApplicationNumber', $model_data[0]['appno'])
                                ->bindValue(':CandidateIP', Yii::$app->request->getUserIP())
                                ->bindValue(':CandidateDownload', 'Score-Card-View')
                                ->execute();
                            // end log   

                            if (count($model_data) > 4) {
                                return $this->render('Scorecard_preview_1', [
                                    'model_data' => $model_data,
                                ]);
                            } else {
                                return $this->render('Scorecard_preview', [
                                    'model_data' => $model_data,
                                ]);
                            }
                        }
                    }
                    if (!empty($data['Scorecard']['email'])) {
                        $candiApplicationNo = "CandidateEmail='" . $data['Scorecard']['email'] . "'";
                        $model_data = Yii::$app->db->createCommand("exec getCommonDataSP :select, :input, :table")
                            ->bindValue(':select', '*')
                            ->bindValue(':input', "WHERE $candiApplicationNo AND dob='$DOB' order by exam_date,exam_shft")
                            ->bindValue(':table', 'Swayam_13_ScoreCard2lot')
                            ->queryAll();


                        if (isset($model_data) && !empty($model_data)) {
                            Yii::$app->session->set('ApplicationNumber', $model_data[0]['appno']);
                            // log
                            Yii::$app->db->createCommand("exec spAdmitCardLog :ApplicationNumber,:CandidateIP,:CandidateDownload")
                                ->bindValue(':ApplicationNumber', $model_data[0]['appno'])
                                ->bindValue(':CandidateIP', Yii::$app->request->getUserIP())
                                ->bindValue(':CandidateDownload', 'Score-Card-View')
                                ->execute();
                            // end log
                            if (count($model_data) > 4) {
                                return $this->render('Scorecard_preview_1', [
                                    'model_data' => $model_data,
                                ]);
                            } else {
                                return $this->render('Scorecard_preview', [
                                    'model_data' => $model_data,
                                ]);
                            }
                        }
                    }
                    if (empty($model_data)) {
                        Yii::$app->session->setFlash('error', 'Please Check your login Details.');
                        return $this->redirect('index');
                    }
                }
            }
        }
        return $this->render('index', [
            'model' => $model,
            'DobDate'   => $DobDate,
            'DobMonth'   => $DobMonth,
            'DobYear'   =>  $DobYear
        ]);
    }

    public function actionScorecardmobile()
    {
        if (isset(yii::$app->params['isMobileOTP']) and yii::$app->params['isMobileOTP'] == 0) {
            return $this->redirect('index');
        }
        $session = Yii::$app->session;
        $session->remove('mobilenumberAdmit');
        $model = new DynamicModel(['MobileNumber']);
        $model->addRule(['MobileNumber'], 'required', ['message' => 'Mobile Number cannot be blank.'])
            ->addRule('MobileNumber', 'integer')
            ->addRule(['MobileOtp', 'MobileNumberotp'], 'safe');    // Optional, safe field
        if ($model->load(Yii::$app->request->post()) && $model->validate()) {
            $data = Yii::$app->request->post();
            $MobileNumber = $data['DynamicModel']['MobileNumber'];
            // $arrayMobile=['8103889020'];
            $arrayMobile =   yii::$app->params['arrayMobile'];          // $model_data = Yii::$app->db->createCommand("exec getCommonDataSP :select, :input, :table")
            //     ->bindValue(':select', '*')
            //     ->bindValue(':input', "WHERE MobileNo='$MobileNumber'")
            //     ->bindValue(':table', 'MobileLoginOtp')
            //     ->queryOne();

            if (in_array($MobileNumber, $arrayMobile)) {
                // if ($model_data) {

                $digits = 4;
                $Motp =  rand(pow(10, $digits - 1), pow(10, $digits) - 1);
                $ExpTime = date("Y-m-d H:i:s", strtotime(date("Y-m-d H:i:s") . " +1440 minutes"));
                $MobileOtp =  $Motp;
                $OtpExpireDate = $ExpTime;
                $MobileVerify = 1;
                $CreateDate = date('Y-m-d H:i:s');
                //  echo "<pre>";print_r($MobileNumber) ;die;                
                Yii::$app->db->createCommand("UPDATE user_otp_verifications set MobileVerify=0 where Mobile=$MobileNumber")->execute();
                $sql = "INSERT INTO user_otp_verifications (MobileOtp,MobileVerify, Mobile)
                        VALUES (:MobileOtp,:MobileVerify, :Mobile)";
                $command = Yii::$app->db->createCommand($sql);
                $command->bindValue(':MobileOtp', $MobileOtp);
                $command->bindValue(':MobileVerify', $MobileVerify);
                $command->bindValue(':Mobile', $MobileNumber);
                $command->execute();
                $var = $MobileOtp;

                $message = "Dear Candidate, Your OTP is $var NTA";
                $mobileno = $MobileNumber;
                $temp = yii::$app->params['OTPSMSTemplate'];
                $data = Yii::$app->SmsComponent->NewSmsAPIGet($mobileno, $message, $temp, true);
                $session = Yii::$app->session;
                $session->set('mobilenumberAdmit', $MobileNumber);
                Yii::$app->session->setFlash('success', 'OTP Send successful');
                return $this->redirect('verifyotp');
            } else {

                Yii::$app->session->setFlash('error', 'Sorry, Record not found');
                return $this->redirect('admitcardmobile');
            }
        }

        return $this->render('Scorecard_mobile', [
            'model' => $model,
        ]);
    }

    public function actionVerifyotp()
    {
        if (isset(yii::$app->params['isMobileOTP']) and yii::$app->params['isMobileOTP'] == 0) {
            return $this->redirect('index');
        }
        $session = Yii::$app->session;
        $mobilenumber = $session->get('mobilenumberAdmit');
        if (empty($mobilenumber)) {
            return $this->redirect('admitcardmobile');
        }
        $modelotp = new DynamicModel(['MobileOtp']);
        $modelotp->addRule(['MobileOtp'], 'required', ['message' => 'Mobile OTP cannot be blank.'])
            ->addRule('MobileOtp', 'integer');

        if ($modelotp->load(Yii::$app->request->post()) && $modelotp->validate()) {

            $data = Yii::$app->request->post();
            $MobileOtp = $data['DynamicModel']['MobileOtp'];
            $mobilenumber = $session->get('mobilenumberAdmit');
            $getData = Yii::$app->db->createCommand("exec getCommonDataSP :select, :input, :table")
                ->bindValue(':select', '*')
                ->bindValue(':input', "WHERE MobileVerify=1 and MobileOtp='" . $MobileOtp . "' and Mobile='" . $mobilenumber . "' ")
                ->bindValue(':table', 'user_otp_verifications')
                ->queryOne();
            if (!empty($getData)) {

                if (Yii::$app->db->createCommand("UPDATE user_otp_verifications set MobileVerify=0 where Mobile=$mobilenumber")->execute()) {
                    $session->set('AccessPermissionAdmit', $mobilenumber);
                    return $this->redirect('index');
                }
            } else {
                Yii::$app->session->setFlash('error', 'Invalid OTP');
                return $this->redirect('verifyotp');
            }
        }

        return $this->render('Scorecard_mobile_verify', [
            'modelotp' => $modelotp,
        ]);
    }
    public function actionLogout()
    {
        // Store the value of 'AccessPermission' before clearing the session
        $accessPermission = Yii::$app->session->get('AccessPermission');

        // Logout the user
        Yii::$app->user->logout();

        // Clear all session data except 'AccessPermission'
        Yii::$app->session->removeAll(); // Clears all session variables
        Yii::$app->session->set('AccessPermission', $accessPermission); // Restore 'AccessPermission'

        return $this->redirect('index');
    }
    public function actionPrintAction()
    {
        $session = Yii::$app->session;
        $candiApplicationNo = $session->get('ApplicationNumber');
        Yii::$app->db->createCommand("exec spAdmitCardLog :ApplicationNumber,:CandidateIP,:CandidateDownload")
            ->bindValue(':ApplicationNumber', $candiApplicationNo)
            ->bindValue(':CandidateIP', Yii::$app->request->getUserIP())
            ->bindValue(':CandidateDownload', 'Score-Card-Download')
            ->execute();
        return json_encode(['success' => true, 'message' => 'Action completed']);
    }
}
